# coding: utf-8

"""
    ARTIK Cloud API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class DevicesStatusApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def get_device_status(self, device_id, **kwargs):
        """
        Get Device Status
        Get Device Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_device_status(device_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str device_id: Device ID. (required)
        :param bool include_snapshot: Include device snapshot into the response
        :param bool include_snapshot_timestamp: Include device snapshot timestamp into the response
        :return: DeviceStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_device_status_with_http_info(device_id, **kwargs)
        else:
            (data) = self.get_device_status_with_http_info(device_id, **kwargs)
            return data

    def get_device_status_with_http_info(self, device_id, **kwargs):
        """
        Get Device Status
        Get Device Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_device_status_with_http_info(device_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str device_id: Device ID. (required)
        :param bool include_snapshot: Include device snapshot into the response
        :param bool include_snapshot_timestamp: Include device snapshot timestamp into the response
        :return: DeviceStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'include_snapshot', 'include_snapshot_timestamp']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_device_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params) or (params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `get_device_status`")


        collection_formats = {}

        resource_path = '/devices/{deviceId}/status'.replace('{format}', 'json')
        path_params = {}
        if 'device_id' in params:
            path_params['deviceId'] = params['device_id']

        query_params = {}
        if 'include_snapshot' in params:
            query_params['includeSnapshot'] = params['include_snapshot']
        if 'include_snapshot_timestamp' in params:
            query_params['includeSnapshotTimestamp'] = params['include_snapshot_timestamp']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['artikcloud_oauth']

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DeviceStatus',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_devices_status(self, dids, **kwargs):
        """
        Get Devices Status
        Get Devices Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_devices_status(dids, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str dids: List of device ids (comma-separated) for which the statuses are requested. (required)
        :param bool include_snapshot: Include device snapshot into the response
        :param bool include_snapshot_timestamp: Include device snapshot timestamp into the response
        :return: DeviceStatusBatch
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_devices_status_with_http_info(dids, **kwargs)
        else:
            (data) = self.get_devices_status_with_http_info(dids, **kwargs)
            return data

    def get_devices_status_with_http_info(self, dids, **kwargs):
        """
        Get Devices Status
        Get Devices Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_devices_status_with_http_info(dids, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str dids: List of device ids (comma-separated) for which the statuses are requested. (required)
        :param bool include_snapshot: Include device snapshot into the response
        :param bool include_snapshot_timestamp: Include device snapshot timestamp into the response
        :return: DeviceStatusBatch
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dids', 'include_snapshot', 'include_snapshot_timestamp']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_devices_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dids' is set
        if ('dids' not in params) or (params['dids'] is None):
            raise ValueError("Missing the required parameter `dids` when calling `get_devices_status`")


        collection_formats = {}

        resource_path = '/devices/status'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'dids' in params:
            query_params['dids'] = params['dids']
        if 'include_snapshot' in params:
            query_params['includeSnapshot'] = params['include_snapshot']
        if 'include_snapshot_timestamp' in params:
            query_params['includeSnapshotTimestamp'] = params['include_snapshot_timestamp']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['artikcloud_oauth']

        return self.api_client.call_api(resource_path, 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DeviceStatusBatch',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def put_device_status(self, device_id, **kwargs):
        """
        Update Device Status
        Update Device Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.put_device_status(device_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str device_id: Device ID. (required)
        :param DeviceStatusPut body: Body
        :return: DeviceStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.put_device_status_with_http_info(device_id, **kwargs)
        else:
            (data) = self.put_device_status_with_http_info(device_id, **kwargs)
            return data

    def put_device_status_with_http_info(self, device_id, **kwargs):
        """
        Update Device Status
        Update Device Status
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.put_device_status_with_http_info(device_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str device_id: Device ID. (required)
        :param DeviceStatusPut body: Body
        :return: DeviceStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'body']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method put_device_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params) or (params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `put_device_status`")


        collection_formats = {}

        resource_path = '/devices/{deviceId}/status'.replace('{format}', 'json')
        path_params = {}
        if 'device_id' in params:
            path_params['deviceId'] = params['device_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['artikcloud_oauth']

        return self.api_client.call_api(resource_path, 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='DeviceStatus',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
